#pragma once

#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <dirent.h>
#include <ctype.h>
#include <unistd.h>
#include <pwd.h>
#include <string.h>
#include <limits.h>
#include <errno.h>
#include <time.h>

#include "manager.h"

struct procs {
        pid_t pid;
        uid_t uid;
        char *username;
        char *command;
        struct procs *next;
};

struct name {
        char *filename;
        struct stat st;
        struct procs *matched_procs;
};

struct inode {
        struct name *name;
        dev_t device;
        ino_t inode;
};

struct device {
        struct name *name;
        dev_t device;
};

#ifndef PATH_MAX
#define PATH_MAX 4096
#endif /* PATH_MAX */

#define CMD_NAME_LEN 100
#define COMM_LEN 64
#define MAX_COMM_LEN 1024
#define PROC_MOUNTS "/proc/mounts"
#define PROC_SWAPS "/proc/swaps"
#define REBOOT_UMOUNT_FILE_NAME "/.reboot-umount-msg.log"
#define MOUNT_FILE_NAME_MAX_LEN 20

int fuser(const char *dir);
